/*
 * @(#)Jorm.java	2010-4-21
 *
 * Copyright (c) 2010 by gerald. All Rights Reserved.
 */

package org.javaclub.jorm;

import java.sql.Connection;

import org.javaclub.jorm.jdbc.SessionFactory;
import org.javaclub.jorm.jdbc.connection.ConnectionManager;
import org.javaclub.jorm.proxy.JormProxy;

/**
 * A utility class for Jorm framework.
 *
 * @author <a href="mailto:gerald.chen@qq.com">Gerald Chen</a>
 * @version $Id: Jorm.java 482 2011-09-26 14:04:03Z gerald.chen.hz $
 */
public class Jorm {
	
	public static Session getSession() {
		return SessionFactory.currentSession();
	}
	
	public static Session newSession() {
		return SessionFactory.newSession();
	}
	
	public static Connection getConnection() {
		return ConnectionManager.getConnection();
	}
	
	public static Session getSession(String providerName) {
		return SessionFactory.getSession(providerName);
	}
	
	public static Connection getConnection(String providerName) {
		return ConnectionManager.getConnection(providerName);
	}
	
	public static void free() {
		SessionFactory.destory();
		ConnectionManager.destory();
	}
	
	public static boolean isInitialize(Object proxy) {
		if ( proxy instanceof JormProxy ) {
			return !( ( JormProxy ) proxy ).getLazyInitializer().isUninitialized();
		}
		else {
			return true;
		}
	}
	
	public static void initialize(Object proxy) throws JormException {
		if ( proxy == null ) {
			return;
		}
		else if ( proxy instanceof JormProxy ) {
			( ( JormProxy ) proxy ).getLazyInitializer().initialize();
		}
	}
	
	public static boolean isProxy(Object proxy) {
		if ( proxy instanceof JormProxy ) {
			return true;
		}
		return false;
	}
	
	public static Object getTarget(Object proxy) {
		if ( proxy instanceof JormProxy ) {
			return ( ( JormProxy ) proxy ).getLazyInitializer()
					.getImplementation();
		} else {
			return proxy;
		}
	}
	
	@SuppressWarnings("unchecked")
	public static Class getClass(Object proxy) {
		if ( proxy instanceof JormProxy ) {
			return ( ( JormProxy ) proxy ).getLazyInitializer()
					.getImplementation()
					.getClass();
		} else {
			return proxy.getClass();
		}
	}

	
	public static final String TEMP_TBNAME = "jorm_tb_";
	
	public static final String COLUMN_PREFIX = "jorm_";
	public static final String COLUMN_SUFFIX = "_jorm_";
	

}
