/*
 * @(#)Id.java	2010-4-21
 *
 * Copyright (c) 2010 by gerald. All Rights Reserved.
 */

package org.javaclub.jorm.annotation;

import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import org.javaclub.jorm.annotation.constant.GenerationType;


/**
 * Specifies the primary key property or field of an entity.
 *
 * @author <a href="mailto:gerald.chen@qq.com">Gerald Chen</a>
 * @version $Id: Id.java 217 2011-08-06 14:06:47Z gerald.chen.hz@gmail.com $
 */
@Target({FIELD}) 
@Retention(RUNTIME)
public @interface Id {

	/**
	 * The primary key generation strategy that the persistence provider must use
	 * to generate the annotated entity primary key.
	 */
	String value() default GenerationType.AUTO;
	
	/**
	 * 
	 * This attribute takes effect only when attribute[value]'s value is
	 * <tt>GenerationType.SEQUENCE</tt>
	 * 
	 * @return
	 */
	String sequenceName() default "";
	
	/**
	 * This attribute takes effect only attribute[value]'s value is
	 * <tt>GenerationType.INCREMENT</tt>
	 *
	 * @return
	 */
	int incrementBy() default 1;
}
