/*
 * @(#)OneToMany.java	2011-9-5
 *
 * Copyright (c) 2011. All Rights Reserved.
 *
 */

package org.javaclub.jorm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * OneToMany
 *
 * @author <a href="mailto:gerald.chen.hz@gmail.com">Gerald Chen</a>
 * @version $Id: OneToMany.java 403 2011-09-19 11:28:01Z gerald.chen.hz $
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
public @interface OneToMany {
	
	Class<?> type();

	/**
	 * if support cascade operation, default is true.
	 *
	 * @return
	 */
	boolean cascade() default true;
	
	/**
	 * "Many" item's foreign key field names.
	 *
	 * @return
	 */
	String[] selField() default {};
	
	/**
	 * "One" item's primary key field names.
	 *
	 * @return
	 */
	String[] ownerField() default {};
}
