/*
 * @(#)OracleDialect.java	May 7, 2009
 *
 * Copyright (c) 2009 by jadmin. All Rights Reserved.
 */

package org.javaclub.jorm.jdbc.sql.impl;

import org.javaclub.jorm.Jorm;




/**
 * SqlDialect for database Oracle.
 *
 * @author <a href="mailto:gerald.chen.hz@gmail.com">Gerald Chen</a>
 * @version $Id: OracleDialect.java 483 2011-09-26 14:04:43Z gerald.chen.hz $
 */
public class OracleDialect extends AbstractDialect {
	
	public OracleDialect() {
		super();
	}
	
	public String pageable(String sql, int start, int limit) {
		return "SELECT * FROM (" 
			        + "SELECT " + Jorm.TEMP_TBNAME + ".*, rownum " + Jorm.COLUMN_PREFIX + "rownum" + Jorm.COLUMN_SUFFIX + 
			        		" FROM (" + sql + ") " + Jorm.TEMP_TBNAME + " WHERE rownum <= " + (start + limit)
		     + ") WHERE " + Jorm.COLUMN_PREFIX + "rownum" + Jorm.COLUMN_SUFFIX + " > " + start;
		// Oracle 'rownum' starts with 1, not like MySQL with 0;
	}
	
	public String getSelectGuidSql() {
		return "select rawtohex(sys_guid()) from dual";
	}
	
	public boolean supportsSequences() {
		return true;
	}

	public boolean supportsLimit() {
		return true;
	}

	public String sequenceNextValSql(String sequenceName) {
		return "select " + sequenceName + ".nextval from dual";
	}
	
}
